Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# TiPullXmlDocument Class Reference

`#include <tinyxml.h>`

Inheritance diagram for TiPullXmlDocument:

[legend]
Collaboration diagram for TiPullXmlDocument:

[legend]
List of all members.

## Public Member Functions
| TiPullXmlDocument ()
| Create an empty document, that has no name.
| TiPullXmlDocument (const char *documentName)
| Create a document with a name. The name of the document is also the filename of the xml.
virtual | ~TiPullXmlDocument ()
bool | LoadFile ()
bool | SaveFile () const
| Save a file using the current document value. Returns true if successful.
bool | LoadFile (const char *filename)
| Load a file using the given filename. Returns true if successful.
bool | SaveFile (const char *filename) const
| Save a file using the given filename. Returns true if successful.
virtual bool | Parse (ParsePosition in, const char *&out, bool throwaway)
TiPullXmlElement * | RootElement ()
bool | Error () const
const char * | ErrorDesc () const
| Contains a textual (english) description of the error if one occurs.
const int | ErrorId () const
int | ErrorRow () const
int | ErrorCol () const
void | SetTabSize (int _tabsize)
int | TabSize () const
void | ClearError ()
void | Print () const
virtual void | Print (FILE *cfile, int depth=0) const
void | SetError (int err, const char *errorLocation, TiPullXmlParsingData *prevData)
const char * | getFileBuffer () const
void | setFileBuffer (const char *buf)
## Protected Member Functions
virtual void | StreamOut (TiXmlOutStream *out) const
void | FindAllLineStarts (const char *p)
int | FindLine (TiPullXmlCursor location) const
## Private Attributes
bool | error
int | errorId
TiXmlString | errorDesc
int | tabsize
TiPullXmlCursor | errorLocation
std::deque< int > | lineStarts
const char * | fileBuffer
## Friends
class | TiPullXmlNode

## Detailed Description

Always the top level node. A document binds together all the XML pieces. It can be saved, loaded, and printed to the screen. The 'value' of a document node is the xml file name.

## Constructor & Destructor Documentation

TiPullXmlDocument::TiPullXmlDocument | ( |  | ) |

| Create an empty document, that has no name.

TiPullXmlDocument::TiPullXmlDocument | ( | const char * | documentName | ) |

| Create a document with a name. The name of the document is also the filename of the xml.

virtual TiPullXmlDocument::~TiPullXmlDocument | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

void TiPullXmlDocument::ClearError | ( |  | ) | `[inline]`

| If you have handled the error, it can be reset with this call. The error state is automatically cleared if you Parse a new XML block.

bool TiPullXmlDocument::Error | ( |  | ) | const`[inline]`

| If an error occurs, Error will be set to true. Also, The ErrorId() will contain the integer identifier of the error (not generally useful) The ErrorDesc() method will return the name of the error. (very useful) The ErrorRow() and ErrorCol() will return the location of the error (if known)

int TiPullXmlDocument::ErrorCol | ( |  | ) | const

const char* TiPullXmlDocument::ErrorDesc | ( |  | ) | const`[inline]`

| Contains a textual (english) description of the error if one occurs.

const int TiPullXmlDocument::ErrorId | ( |  | ) | const`[inline]`

| Generally, you probably want the error string ( ErrorDesc() ). But if you prefer the ErrorId, this function will fetch it.

int TiPullXmlDocument::ErrorRow | ( |  | ) | const

| Returns the location (if known) of the error. The first column is column 1, and the first row is row 1. A value of 0 means the row and column wasn't applicable (memory errors, for example, have no row/column) or the parser lost the error. (An error in the error reporting, in that case.) See also: SetTabSize, Row, Column

void TiPullXmlDocument::FindAllLineStarts | ( | const char * | p | ) | `[protected]`

int TiPullXmlDocument::FindLine | ( | TiPullXmlCursor | location | ) | const`[protected]`

const char* TiPullXmlDocument::getFileBuffer | ( |  | ) | const`[inline]`

bool TiPullXmlDocument::LoadFile | ( | const char * | filename | ) |

| Load a file using the given filename. Returns true if successful.

bool TiPullXmlDocument::LoadFile | ( |  | ) |

| Load a file using the current document value. Returns true if successful. Will delete any existing document data before loading.

bool TiPullXmlDocument::Parse | ( | ParsePosition | in,
|  | const char *& | out,
|  | bool | throwaway
| ) | `[virtual]`

| Parse the given null terminated block of xml data. Implements TiPullXmlBase.

void TiPullXmlDocument::Print | ( | FILE * | cfile,
|  | int | depth = 0
| ) | const`[virtual]`

| All TinyXml classes can print themselves to a filestream. This is a formatted print, and will insert tabs and newlines. (For an unformatted stream, use the << operator.) Implements TiPullXmlBase.

void TiPullXmlDocument::Print | ( |  | ) | const`[inline]`

| Dump the document to standard out.

TiPullXmlElement* TiPullXmlDocument::RootElement | ( |  | ) | `[inline]`

| Get the root element -- the only top level element -- of the document. In well formed XML, there should only be one. TinyXml is tolerant of multiple elements at the document level.

bool TiPullXmlDocument::SaveFile | ( | const char * | filename | ) | const

| Save a file using the given filename. Returns true if successful.

bool TiPullXmlDocument::SaveFile | ( |  | ) | const

| Save a file using the current document value. Returns true if successful.

void TiPullXmlDocument::SetError | ( | int | err,
|  | const char * | errorLocation,
|  | TiPullXmlParsingData * | prevData
| ) |

void TiPullXmlDocument::setFileBuffer | ( | const char * | buf | ) | `[inline]`

void TiPullXmlDocument::SetTabSize | ( | int | _tabsize | ) | `[inline]`

| By calling this method, with a tab size greater than 0, the row and column of each node and attribute is stored when the file is loaded. Very useful for tracking the DOM back in to the source file. The tab size is required for calculating the location of nodes. If not set, the default of 4 is used. The tabsize is set per document. Setting the tabsize to 0 disables row/column tracking. Note that row and column tracking is not supported when using operator>>. The tab size needs to be enabled before the parse or load. Correct usage:
    		TiPullXmlDocument doc;
    		doc.SetTabSize( 8 );
    		doc.Load( "myfile.xml" );
See also: Row, Column

void TiPullXmlDocument::StreamOut | ( | TiXmlOutStream * | out | ) | const`[protected, virtual]`

| Implements TiPullXmlBase.

int TiPullXmlDocument::TabSize | ( |  | ) | const`[inline]`

## Friends And Related Function Documentation

friend class TiPullXmlNode`[friend]`

| Reimplemented from TiPullXmlBase.

## Member Data Documentation

bool TiPullXmlDocument::error`[private]`

TiXmlString TiPullXmlDocument::errorDesc`[private]`

int TiPullXmlDocument::errorId`[private]`

TiPullXmlCursor TiPullXmlDocument::errorLocation`[private]`

const char* TiPullXmlDocument::fileBuffer`[private]`

std::deque<int> TiPullXmlDocument::lineStarts`[private]`

int TiPullXmlDocument::tabsize`[private]`

The documentation for this class was generated from the following files:

- pull/tinyxml.h
- pull/tinyxml.cpp
- pull/tinyxmlparser.cpp